#ifndef POLINOM_H_INCLUDED
#define POLINOM_H_INCLUDED

#include <vector>

struct Polinom
{
    private:
        std::vector<double> coefficients;

    public:
        Polinom();
        Polinom(const std::vector<double> &coefficients);
        double getCoefficient(int index) const;
        void setCoefficient(int index, double value);
        double evaluate(double x) const;

        friend Polinom operator+(const Polinom &a, const Polinom &b);
        friend Polinom operator-(const Polinom &a, const Polinom &b);
        friend Polinom operator*(const Polinom &a, const Polinom &b);
        friend std::istream& operator>>(std::istream &in, Polinom &p);
        friend std::ostream& operator<<(std::ostream &out, const Polinom &p);

    private:
        void simplify();
};

#endif // POLINOM_H_INCLUDED
